"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../utils/constants");
var ApiGatewayResponseBuilder = /** @class */ (function () {
    function ApiGatewayResponseBuilder(statusCode, body) {
        var _this = this;
        this.withCors = function () {
            _this.headers[constants_1.HEADER_CORS_ACCESS_CONTROL_ALLOW_ORIGIN] = '*';
            _this.headers[constants_1.HEADER_CORS_ACCESS_CONTROL_ALLOW_CREDENTIALS] = true;
            _this.headers[constants_1.HEADER_CONTENT_TYPE] = 'application/json';
            return _this;
        };
        this.build = function () {
            return {
                statusCode: _this.statusCode,
                body: _this.isBase64Encoded ? _this.body : JSON.stringify(_this.body),
                headers: _this.headers,
                isBase64Encoded: _this.isBase64Encoded
            };
        };
        this.statusCode = statusCode;
        this.body = body ? body : {};
        this.headers = {};
        this.isBase64Encoded = false;
    }
    ApiGatewayResponseBuilder.prototype.withHeader = function (header, value) {
        this.headers[header] = value;
        return this;
    };
    ApiGatewayResponseBuilder.prototype.withHeaders = function (headers) {
        this.headers = __assign(__assign({}, this.headers), headers);
        return this;
    };
    ApiGatewayResponseBuilder.prototype.withBase64Encoding = function () {
        this.isBase64Encoded = true;
        return this;
    };
    return ApiGatewayResponseBuilder;
}());
exports.ApiGatewayResponseBuilder = ApiGatewayResponseBuilder;
